
/* All conditionals taken outside of loop and loop replicated, if Cyc == 2. */
/* This file contains all the proceedures for each instance of hh.mat loop.*/
/* Cyc (i,j) loops unwrapped for speed, if Cyc == 1 | 2. */
/*jcr24jul90*/

/* jcr13jul92 qemhb copied from emhb.c and modified for quad prec. option*/
/* jcr17jul92 removed interpolation, was not accurate for small, low freq*/

#include "local.h"
#include <math.h>
#include <stdio.h>  /*For NULL definition*/
#include "em.typ"
#include "hharray.h"
#include "son.h"

/*Global variables for hh array load*/
extern Rtyp ff_re,ff_im;
extern int Capm,Capn,Capm2,Capn2;
extern int loss,xsym;
extern int mo_odd,no_odd;
extern struct qhharray qhh;
extern int gx,gy;  /* = 1 for cos, = 0 for sin */
extern void (*ffp)();  /*pointer to function to do ff term, e.g., ff*/
extern int *ni0,*mi0;
extern RRtyp *qhre,*qhim,*qhrez,*qhimz;

qhlp24c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* mo_odd && !no_odd && !gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp24c2*/

qhlp16c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* !mo_odd && !no_odd && !gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp16c2*/

qhlp15c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* mo_odd && no_odd && gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp15c1*/

qhlp7c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* !mo_odd && no_odd && gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp7c1*/

qhlp11c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /*mo_odd && !no_odd && gx && gy*/

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp11c1*/

qhlp3c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* !mo_odd && !no_odd && gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp3c1*/

qhlp13c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* mo_odd && no_odd && !gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp13c1*/

qhlp5c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* !mo_odd && no_odd && !gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp5c1*/

qhlp9c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* mo_odd && !no_odd && !gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp9c1*/

qhlp1c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* !mo_odd && !no_odd && !gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp1c1*/

qhlp14c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* mo_odd && no_odd && gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp14c1*/

qhlp6c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* !mo_odd && no_odd && gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp6c1*/

qhlp10c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* mo_odd && !no_odd && gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp10c1*/

qhlp2c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* !mo_odd && !no_odd && gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp2c1*/

qhlp12c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* mo_odd && no_odd && !gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp12c1*/

qhlp4c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* !mo_odd && no_odd && !gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp4c1*/

qhlp8c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* mo_odd && !no_odd && !gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp8c1*/

qhlp0c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* !mo_odd && !no_odd && !gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp0c1*/

qhlp31c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /*loss &&  mo_odd && no_odd && gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp31c1*/

qhlp23c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* !mo_odd && no_odd && gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp23c1*/

qhlp27c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /*mo_odd && !no_odd && gx && gy*/

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp27c1*/

qhlp19c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* !mo_odd && !no_odd && gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp19c1*/

qhlp29c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* mo_odd && no_odd && !gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp29c1*/

qhlp21c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* !mo_odd && no_odd && !gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp21c1*/

qhlp25c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* mo_odd && !no_odd && !gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp25c1*/

qhlp17c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* !mo_odd && !no_odd && !gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp17c1*/

qhlp30c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* mo_odd && no_odd && gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp30c1*/

qhlp22c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* !mo_odd && no_odd && gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp22c1*/

qhlp26c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* mo_odd && !no_odd && gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp26c1*/

qhlp18c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* !mo_odd && !no_odd && gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp18c1*/

qhlp28c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* mo_odd && no_odd && !gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp28c1*/

qhlp20c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* !mo_odd && no_odd && !gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp20c1*/

qhlp24c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* mo_odd && !no_odd && !gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp24c1*/

qhlp16c1(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* !mo_odd && !no_odd && !gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp16c1*/

qcs_fft(A,gcos,odd,sym,N)  RRtyp *A;  int gcos,odd,sym,N;
/*************************************************************/
/* Oversee evaluation of the appropriate cos/sin series.     */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr17feb89 */ 
{ int M,Ntry;

  /*If N=0, we just want to free temp dynamic arrays*/
  if (N==0)
  { qcs_fft_sym(NULL,NULL,0,0);  /*This one also cleans out qcs_fft_full*/
    qcs_dft_full(NULL,0,0,0);
    qcs_dft_sym(NULL,0,0,0);
    return;
  }

  /*Calculate M=log2(N)*/
  for (M=0,Ntry=1; Ntry<N; Ntry=Ntry<<1)
    if ( (++M)>=16 )
    { fprintf(stderr,"\nem: bad qcs_fft size.\n");
      announce_bug("qcs_fft");
    }

  /*If N is not a power of two, just do a dft*/
  if (N != 1<<M || N<16)
  { if (sym) qcs_dft_sym(A,gcos,odd,N);
    else     qcs_dft_full(A,gcos,odd,N);
    return;
  }

  if (sym) { if (gcos) qcs_fft_sym(A,NULL,odd,M);
             else      qcs_fft_sym(NULL,A,odd,M);
	   }
  else     { if (gcos) qcs_fft_full(A,NULL,odd,M);
             else      qcs_fft_full(NULL,A,odd,M);
           }

} /*qcs_fft*/

qcs_dft_full(A,gcos,odd,N0)  RRtyp *A;  int gcos,odd,N0;
/*************************************************************/
/* Do a full cos/sin series (0..N/2).                        */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr23feb89 */ 
/*Ac or As pts to N/2 items and returns N/2+1 (!odd) or N/2 (odd) items.*/
/*To clean up dynamic allocations, call with N0=0*/
{ static RRtyp *B=NULL;
  static int Nb=0;
  RRtyp *sin_arr;
  int i,n,k,N2,N3,N4,end,index,thm;
  register RRtyp rrtmp;
  RRtyp *ffb_qsin();

  if (N0==0)  /*Clean up and return*/
  { if (B!=NULL) sFree( (char *)B);  B = NULL;  Nb = 0;
    return;
  }

  odd = !!odd;
  N2 = N0>>1;  N3 = N2 + !(odd);  N4 = 2*N0;

  /*Check that enough memory is allocated for B*/
  if (Nb<N0)
  { if (B!=NULL) sFree( (char *)B);
    B = (RRtyp *)new( N2*sizeof(RRtyp) );  Nb = N0;
  }
  /*Copy A into B*/
  for (i=0; i<N2; i++) *(B+i) = *(A+i);

  sin_arr = ffb_qsin(N0,&thm);

  /*Do the dft*/
  /*end is the index of the last (pi/2) element in sin_arr*/
  end = (thm * N0)>>1;
  if (gcos) for (i=0; i<N3; i++)
  { rrtmp = 0.0;  k =  2*i + odd;
    for (n=0; n<N2; n++)
    { index = thm * ((n * k) % N4);
      if ( index <= end )
	rrtmp += *(B+n) * *(sin_arr + end-index); 
      else if ( index <= 2*end )
	rrtmp -= *(B+n) * *(sin_arr + index-end); 
      else if ( index <= 3*end )
        rrtmp -= *(B+n) * *(sin_arr + 3*end-index); 
      else
        rrtmp += *(B+n) * *(sin_arr + index-3*end); 
    }
    *(A+i) = rrtmp;
  }
  else for (i=0; i<N3; i++)
  { rrtmp = 0.0;  k =  2*i + odd;
    for (n=0; n<N2; n++)
    { index = thm*((n * k) % N4);
      if ( index <= end )
	rrtmp += *(B+n) * *(sin_arr + index); 
      else if ( index <= 2*end )
	rrtmp += *(B+n) * *(sin_arr + 2*end-index); 
      else if ( index <= 3*end )
        rrtmp -= *(B+n) * *(sin_arr + index-2*end); 
      else
        rrtmp -= *(B+n) * *(sin_arr + 4*end-index); 
    }
    *(A+i) = rrtmp;
  }

} /*qcs_dft_full*/

qcs_dft_sym(A,gcos,odd,N0)  RRtyp *A;  int gcos,odd,N0;
/*************************************************************/
/* Do a full cos/sin series (0..N/2).                        */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr23feb89 */ 
/*Ac or As pts to N/2 items and returns N/2+1 (!odd) or N/2 (odd) items.*/
/*To clean up dynamic allocations, call with N0=0*/
{ static RRtyp *B=NULL;
  static RRtyp *sin_arr=NULL;
  static int Nb=0;
  int i,n,k,N2,N3,N4,NN4,end,index,thm;
  register RRtyp rrtmp;
  RRtyp *ffb_qsin();

  if (N0==0)  /*Clean up and return*/
  { if (B!=NULL) sFree( (char *)B);  B = NULL;  Nb = 0;
    return;
  }

  odd = !!odd;
  N2 = N0>>1;  N3 = ((!odd) && (!(N2&1))) + ((N2+1)>>1);
  N4 = 2*N0;  NN4 = N2>>1;

  /*Check that enough memory is allocated for B*/
  if (Nb<N0)
  { if (B!=NULL) sFree( (char *)B);
    B = (RRtyp *)new( NN4*sizeof(RRtyp) );  Nb = N0;
  }
  /*Copy A into B*/
  for (i=0; i<NN4; i++) *(B+i) = *(A+i);

  sin_arr = ffb_qsin(N0,&thm);

  /*Do the dft*/
  /*end is the index of the last (pi/2) element in sin_arr*/
  end = (thm * N0)>>1;
  if (gcos) for (i=0; i<N3; i++)
  { rrtmp = 0.0;  k =  2*i + odd;
    for (n=1; n<N2; n += 2)
    { index = thm * ((n * k) % N4);
      if ( index <= end )
	rrtmp += *(B+(n>>1)) * *(sin_arr + end-index); 
      else if ( index <= 2*end )
	rrtmp -= *(B+(n>>1)) * *(sin_arr + index-end); 
      else if ( index <= 3*end )
        rrtmp -= *(B+(n>>1)) * *(sin_arr + 3*end-index); 
      else
        rrtmp += *(B+(n>>1)) * *(sin_arr + index-3*end); 
    }
    *(A+i) = rrtmp;
  }
  else for (i=0; i<N3; i++)
  { rrtmp = 0.0;  k =  2*i + odd;
    for (n=1; n<N2; n += 2)
    { index = thm*((n * k) % N4);
      if ( index <= end )
	rrtmp += *(B+(n>>1)) * *(sin_arr + index); 
      else if ( index <= 2*end )
	rrtmp += *(B+(n>>1)) * *(sin_arr + 2*end-index); 
      else if ( index <= 3*end )
        rrtmp -= *(B+(n>>1)) * *(sin_arr + index-2*end); 
      else
        rrtmp -= *(B+(n>>1)) * *(sin_arr + 4*end-index); 
    }
    *(A+i) = rrtmp;
  }

} /*qcs_dft_sym*/

qcs_fft_full(Ac,As,odd,M) RRtyp *Ac,*As;  int odd,M;
/*************************************************************/
/* Do a full cos/sin series (0..N/2).                        */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr17feb89 */ 
/*Ac or As pts to N/2 items and returns N/2+1 (!odd) or N/2 (odd) items.*/
/*For just a cosine series, As==NULL; Sine series, Ac==NULL.  For both*/
/*Pass nums in Ac and have As point to N/2 or N/2+1 items*/
/*To clean up dynamic allocations, call with M=0*/
{ static RRtyp *B=NULL;
  static RRtyp *C=NULL;
  static int Nb=0;
  static int Nc=0;
  RRtyp *sin_arr=NULL;
  int i,N,N2,thm;
  RRtyp *ffb_qsin();

  if (M==0)  /*Clean up and return*/
  { if (B!=NULL) sFree( (char *)B);  B = NULL;  Nb = 0;
    if (C!=NULL) sFree( (char *)C);  C = NULL;  Nc = 0;
    return;
  }

  N = 1<<M;  N2 = N>>1;

  /*Check that enough memory is allocated for B*/
  if (Nb<N)
  { if (B!=NULL) sFree( (char *)B);
    B = (RRtyp *)cnew( (N+2),sizeof(RRtyp) );  Nb = N;
  }
  else /*Clear the tail end of B*/
  for (i=N2; i<(N+2); i++) *(B+i) = 0.0;

  /*Do the FFT for the even case*/
  if (!odd)
  { if (Ac) for (i=0; i<N2; i++) *(B+i) = *(Ac+i);
    else for (i=0; i<N2; i++) *(B+i) = *(As+i);
    qffb(B,M);
    if (Ac) for (i=0; i<=N2; i++) *(Ac+i) = *(B+2*i);
    if (As) for (i=0; i<=N2; i++) *(As+i) = - *(B+2*i+1);
    return;
  }

  /*Only odd case now*/

  if (Nc<N) /*Do set up of C*/
  { if (C!=NULL) sFree( (char *)C);
    C = (RRtyp *)cnew( (N+2),sizeof(RRtyp) );  Nc = N;
  }
  else /*Clear out the tail end of C*/
    for (i=N2; i<(N+2); i++) *(C+i) = 0.0;

  sin_arr = ffb_qsin(N,&thm);

  /*Pre-process A and copy into B and C*/
  if (Ac) for (i=0; i<N2; i++)
  { *(C+i) = *(Ac+i) * *(sin_arr + thm*i);
    *(B+i) = *(Ac+i) * *(sin_arr + thm*(N2-i));  /*cos*/
  }
  else for (i=0; i<N2; i++)
  { *(C+i) = *(As+i) * *(sin_arr + thm*i);
    *(B+i) = *(As+i) * *(sin_arr + thm*(N2-i)); }

  /*Do the FFT for the odd case*/
  qffb(B,M);  qffb(C,M);
  if (Ac) for (i=0; i<N2; i++)  *(Ac+i) = *(B+2*i) + *(C+2*i+1);
  if (As) for (i=0; i<N2; i++)  *(As+i) = *(C+2*i) - *(B+2*i+1);

} /*qcs_fft_full*/

qcs_fft_sym(Ac,As,odd,M)  RRtyp *Ac,*As;  int odd,M;
/*************************************************************/
/* Do a cos/sin series with only odd mode #'s (0..N/2-1).    */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr17feb89 */ 
/*A points to N/4 numbers and is returned with N/4 numbers
 (odd) or N/4+1 (!odd)*/
/*For just a cosine series, As==NULL; Sine series, Ac==NULL.  For both*/
/*Pass nums in Ac and have As point to N/4 or N/4+1 items*/
{ static RRtyp *Bc=NULL;
  static RRtyp *Bs=NULL;
  static int Nb=0;
  RRtyp *sin_arr=NULL;
  int i,j,k,N,N2,N4,thm;
  RRtyp *ffb_qsin();

  if (M==0)  /*Clean up and return*/
  { if (Bc!=NULL) sFree( (char *)Bc);  Bc = NULL;  Nb = 0;
    if (Bs!=NULL) sFree( (char *)Bs);  Bs = NULL;
    qcs_fft_full(NULL,NULL,0,0);
    return;
  }

  N = 1<<M;  N2 = N>>1;  N4 = N2>>1;

  /*Check that enough memory is allocated for Bc,Bs*/
  if (Nb<N)
  { if (Bc!=NULL) sFree( (char *)Bc);
    Bc = (RRtyp *)cnew( (N4+1),sizeof(RRtyp) );  Nb = N;
    if (Bs!=NULL) sFree( (char *)Bs);
    Bs = (RRtyp *)cnew( (N4+1),sizeof(RRtyp) );
  }
  /*Copy Ac or As into Bc*/
  if (Ac) for (i=0; i<N4; i++) *(Bc+i) = *(Ac+i);
  else    for (i=0; i<N4; i++) *(Bc+i) = *(As+i);

  /*Get both the cos and sin series*/
  qcs_fft_full(Bc,Bs,odd,M-1);

  /*Set up the sin arrays*/
  sin_arr = ffb_qsin(N,&thm);

  /*Finish it off*/
  if (Ac)
  { if (odd)
      for (i=0,j=thm,k=thm*(N2-1); i<N4; i++,j += 2*thm, k -= 2*thm)
        *(Ac+i) = *(Bc+i) * *(sin_arr+k) - *(Bs+i) * *(sin_arr+j);
    else
      for (i=0,j=0,k=thm*N2; i<=N4; i++,j += 2*thm, k -= 2*thm)
        *(Ac+i) = *(Bc+i) * *(sin_arr+k) - *(Bs+i) * *(sin_arr+j);
  }
  if (As)
  { if (odd)
      for (i=0,j=thm,k=thm*(N2-1); i<N4; i++,j += 2*thm, k -= 2*thm)
        *(As+i) = *(Bc+i) * *(sin_arr+j) + *(Bs+i) * *(sin_arr+k);
    else
      for (i=0,j=0,k=thm*N2; i<=N4; i++,j += 2*thm, k -= 2*thm)
        *(As+i) = *(Bc+i) * *(sin_arr+j) + *(Bs+i) * *(sin_arr+k);
  }
} /*qcs_fft_sym*/
